<template>
  <div class="app-container calendar-list-container">

    <!-- 查询和其他操作 -->
    <div class="filter-container">
      <el-input clearable class="filter-item" style="width: 200px;" placeholder="请输入名称"
        v-model="listQuery.couponName"></el-input>
      <el-select v-model="listQuery.couponType" clearable placeholder="请选择类型" class="filter-item" style="width: 200px">
        <el-option :key="item.type" v-for="item in typeList" :label="item.name" :value="item.type">
        </el-option>
      </el-select>
      <el-date-picker class="filter-item" value-format="yyyy-MM-dd" v-model="listQuery.enableEndTime" type="date"
        placeholder="截止日期">
      </el-date-picker>
      <el-date-picker class="filter-item" value-format="yyyy-MM-dd" v-model="listQuery.createTime" type="date"
        placeholder="创建日期">
      </el-date-picker>
      <el-button class="filter-item" type="primary" v-waves icon="el-icon-search" @click="handleFilter">查找</el-button>
      <el-button class="filter-item" type="primary" @click="handleCreate" icon="el-icon-edit">添加</el-button>
      <!-- <el-button class="filter-item" type="warning" icon="el-icon-delete" @click="delAll">批量删除</el-button> -->
    </div>

    <!-- 查询结果 -->
    <el-table size="small" :data="list" @selection-change="handleSelectionChange" v-loading="listLoading"
      element-loading-text="正在查询中。。。" border fit highlight-current-row>
      <el-table-column type="selection" width="55px"> </el-table-column>
      <el-table-column type="index" label="序号" header-align="center" align="center">
      </el-table-column>

      <el-table-column align="center" min-width="100px" label="名称" prop="couponName">
      </el-table-column>
      <el-table-column align="center" min-width="80px" label="类型" prop="couponTypeName">
      </el-table-column>
      <el-table-column align="center" min-width="80px" label="数量" prop="num">
      </el-table-column>
      <el-table-column align="center" min-width="150px" label="截止日期" prop="enableEndTime">
      </el-table-column>
      <el-table-column align="center" min-width="100px" label="状态" prop="statusName">
      </el-table-column>
      <el-table-column align="center" min-width="150px" label="创建时间" prop="createTime">
      </el-table-column>
      <el-table-column align="center" label="操作" width="240px" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button type="primary" size="small" @click="handleUpdate(scope.row, false)">编辑</el-button>

          <el-button type="danger" size="small" @click="handleDelete(scope.row)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!-- 分页 -->
    <div class="pagination-container">
      <el-pagination background @size-change="handleSizeChange" @current-change="handleCurrentChange"
        :current-page="listQuery.page" :page-sizes="[10, 20, 30, 50]" :page-size="listQuery.limit"
        layout="total, sizes, prev, pager, next, jumper" :total="total">
      </el-pagination>
    </div>

    <!-- 添加或修改对话框 -->
    <el-dialog :close-on-click-modal="false" :title="textMap[dialogStatus]" :visible.sync="dialogFormVisible" width="40%">
      <el-form :rules="rules" ref="dataForm" :model="dataForm" status-icon label-position="left" label-width="80px"
        style='width: 700px; margin-left:50px;'>
        <el-form-item label="名称" prop="couponName">
          <el-input style="width: 300px" v-model="dataForm.couponName"></el-input>
        </el-form-item>
        <el-form-item style="width: 800px" label="图片" prop="couponImg">
                    <el-upload :limit="1" :action="fileImgUrl" list-type="picture-card" :file-list="dataForm.images"
                            :on-success="handleGallerySucess" :on-exceed="handleExceed" :before-upload="uploadBannerImg"
                            :on-remove="handleRemove">
                            <i class="el-icon-plus"></i>
                        </el-upload>
                </el-form-item>
        <el-form-item label="类型" prop="couponType">
          <el-select :disabled="dialogStatus == 'update'?true:false" v-model="dataForm.couponType" clearable placeholder="请选择类型" class="filter-item" style="width: 300px">
            <el-option :key="item.type" v-for="item in typeList" :label="item.name" :value="item.type">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="使用类型" prop="useType">
          <el-select :disabled="dialogStatus == 'update'?true:false" v-model="dataForm.useType" clearable placeholder="请选择类型" class="filter-item" style="width: 300px">
            <el-option :key="item.dictValue" v-for="item in dataTypeList" :label="item.dictLabel" :value="item.dictValue">
                        </el-option>
          </el-select>
        </el-form-item>
        <el-form-item v-if="dataForm.useType=='1'" label="商品" prop="skuIds">
          <el-select :disabled="dialogStatus == 'update'?true:false" v-model="dataForm.skuIds" clearable multiple collapse-tags placeholder="请选择商品" class="filter-item" style="width: 300px">
            <el-option :key="item.skuId" v-for="item in goodsList" :label="item.name" :value="item.skuId">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item v-else label="分类" prop="categorys">
          <el-select :disabled="dialogStatus == 'update'?true:false" v-model="dataForm.categorys" clearable  multiple collapse-tags placeholder="请选择分类" class="filter-item" style="width: 300px">
            <el-option :key="item.dictValue" v-for="item in categorysList" :label="item.dictLabel" :value="item.dictValue">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item v-if="dataForm.couponType=='2'" label="截止日期" prop="enableEndTime">
          <el-date-picker :disabled="dialogStatus == 'update'?true:false" style="width: 300px" class="filter-item" value-format="yyyy-MM-dd"
            v-model="dataForm.enableEndTime" type="date" placeholder="截止日期">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="数量" prop="num">
          <el-input-number :disabled="dialogStatus == 'update'?true:false" :min="1" :precision="0" :step="1" v-model="dataForm.num"></el-input-number>
        </el-form-item>
        <el-form-item label="状态">
          <el-radio-group :disabled="dialogStatus == 'update'?true:false" v-model="dataForm.status">
            <el-radio :label="'0'">关闭</el-radio>
            <el-radio :label="'1'">开启</el-radio>
          </el-radio-group>
        </el-form-item>
        <!-- <el-form-item label="备注">
          <el-input type="textarea" :rows="2" style="width: 300px" v-model="dataForm.remark"></el-input>
        </el-form-item> -->


      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogFormVisible = false">取消</el-button>
        <el-button v-if="dialogStatus == 'create'" type="primary" @click="createData">确定</el-button>
        <el-button v-else type="primary" @click="updateData">确定</el-button>
      </div>
    </el-dialog>

  </div>
</template>
  
<style>
.demo-table-expand {
  font-size: 0;
}

.demo-table-expand label {
  width: 200px;
  color: #99a9bf;
}

.demo-table-expand .el-form-item {
  margin-right: 0;
  margin-bottom: 0;
}
</style>
  
<script>
import { list, createItem, updateItem, deleteitem } from "@/api/couponsManage";
import { goodsList,dataTypeList } from "@/api/public";
import waves from "@/directive/waves"; // 水波纹指令
import Tinymce from '@/components/Tinymce'

export default {
  components: { Tinymce },
  directives: { waves },
  data() {
    return {
      fileImgUrl: this.upLoadUrl,
      categorysList:[],
      dataTypeList:[],
      goodsList:[],
      typeList: [
        {
          type: "1",
          name: "永久",
        },
        {
          type: "2",
          name: "有效",
        },
      ],
      list: [

      ],
      delarr: [],
      multipleSelection: [],
      total: 0,
      listLoading: false,
      listQuery: {
        page: 1,
        limit: 10,
        couponName: '',
        couponType: '',
        enableEndTime: '',
        createTime: '',
      },
      dataForm: {
        couponImg: undefined,
        images: [],
        couponName: undefined,
        couponType: undefined,
        useType:undefined,
        categorys:[],
        skuIds: [],
        enableEndTime: undefined,
        num: undefined,
        status: '1',
        remark: undefined,
      },
      dialogFormVisible: false,
      dialogStatus: '',
      textMap: {
        update: "编辑",
        create: "创建",
      },
      imageUrl: undefined,
      rules: {
        couponImg: [{ required: true, message: "请上传奖品图片", trigger: "blur" }],
        couponName: [{ required: true, message: "名称不能为空", trigger: "blur" }],
        couponType: [{ required: true, message: "请选择类型", trigger: "blur" }],
        useType: [{ required: true, message: "请选择使用类型", trigger: "blur" }],
        categorys: [{ required: true, message: "请选择分类", trigger: "blur" }],
        skuIds: [{ required: true, message: "请选择商品", trigger: "blur" }],
        enableEndTime: [{ required: true, message: "请选择截止日期", trigger: "blur" }],
        num: [{ required: true, message: "数量不能为空", trigger: "blur" }],
      },
    }
  },
  created() {
    this.getList();
    this.getGoodsList();
    this.getDataTypeList();
    this.getCategorysList();
  },
  methods: {
    handleRemove(file, fileList) {
            console.log(file, fileList);
            let images = [];
            for (let i in fileList) {
                let response = fileList[i].response;
                let url = response.data.url;
                images.push(url);
            }
            this.dataForm.images = images;
            this.dataForm.couponImg = images.join(",");
        },
        uploadBannerImg(file) {
            const isJPGs = file.type === "image/jpeg";
            console.log(isJPGs);
        },
        handleExceed(files, fileList) {
            this.$message.warning(
                `当前限制选择 1 个文件，本次选择了 ${files.length} 个文件！，共选择了 ${files.length + fileList.length
                } 个文件`
            );
        },
        handleGallerySucess(res, file, fileList) {
            this.dataForm.couponImg = ""; // 清空画廊图片数组

            let images = [];
            for (let i in fileList) {
                let response = fileList[i].response;
                if (response.errno && response.errno != "0") {
                    this.$message.error("该图片上传失败,已被移除,请重新上传!");
                    // 上传失败移除该 file 对象
                    fileList.splice(i, 1);
                } else {
                    let url = response.data.url;
                    images.push(url);
                }
            }
            this.dataForm.images = images;
            this.dataForm.couponImg = images.join(",");
            console.log(this.dataForm.couponImg)
        },
    getCategorysList() {
            dataTypeList({dictType:'mall_sku_attribute'}).then(response => {
                this.categorysList = response.data.data;
            }).catch(() => {});
        },
    getDataTypeList() {
            dataTypeList({dictType:'coupon_use_type'}).then(response => {
                this.dataTypeList = response.data.data;
            }).catch(() => {});
        },
    getGoodsList() {
      goodsList({}).then(response => {
        this.goodsList = response.data.data;
      }).catch(() => { });
    },
    resetForm() {
      this.dataForm = {
        couponImg: undefined,
        images: [],
        couponName: undefined,
        couponType: undefined,
        useType:undefined,
        categorys:[],
        skuIds: [],
        enableEndTime: undefined,
        num: undefined,
        status: '1',
        remark: undefined,
      };
    },
    handleCreate() {
      this.resetForm();
      this.dialogFormVisible = true;
      this.dialogStatus = "create";
      this.$nextTick(() => {
        this.$refs["dataForm"].clearValidate();
      });
    },
    createData() {
      this.$refs["dataForm"].validate((valid) => {
        if (valid) {
          createItem(this.dataForm)
            .then(() => {
              this.getList();
              this.dialogFormVisible = false;

              this.$notify({
                title: "成功",
                message: "创建成功",
                type: "success",
                duration: 2000,
              });
              this.getList()
            })
        }
      });
    },
    getList() {
      this.listLoading = true
      list(this.listQuery).then(response => {
        this.list = response.data.data.items
        this.total = response.data.data.total
        this.listLoading = false
      }).catch(() => {
        this.list = []
        this.total = 0
        this.listLoading = false
      })
    },

    handleFilter() {
      this.listQuery.page = 1
      this.getList()
    },

    handleSizeChange(val) {
      this.listQuery.limit = val
      this.getList()
    },

    handleCurrentChange(val) {
      this.listQuery.page = val
      this.getList()
    },

    handleUpdate(row) {
      this.dataForm = Object.assign({}, row);
      if (this.dataForm.couponImg) {
                let images = this.dataForm.couponImg.split(",");
                this.dataForm.images = [];
                for (let i in images) {
                    let url = images[i];
                    let name = "image_" + i;

                    this.dataForm.images.push({
                        name: name,
                        url: url,
                        response: { error: "0", data: { url: url } },
                    });
                }
            }
      if(this.dataForm.categorys==null){
        this.dataForm.categorys=[];
      }
      if(this.dataForm.skuIds==null){
        this.dataForm.skuIds=[];
      }
      this.dialogStatus = 'update'
      this.dialogFormVisible = true
      this.$nextTick(() => {
        this.$refs['dataForm'].clearValidate()
      })
    },

    updateData() {
      this.$refs['dataForm'].validate((valid) => {
        if (valid) {
          updateItem(this.dataForm).then(() => {
            this.dialogFormVisible = false
            this.$notify({
              title: '成功',
              message: '更新成功',
              type: 'success',
              duration: 2000
            })
            this.getList()
          })

        }
      })
    },

    handleDelete(row) {

      this.$confirm('确认删除吗?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        deleteitem({ couponId: row.id,status:-1 }).then(response => {
          this.$notify({
            title: '成功',
            message: '删除成功',
            type: 'success',
            duration: 2000
          })
          this.getList()
        })
      }).catch(() => {

      })

    },
    delAll() {
      this.$confirm("确认删除吗?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          const length = this.multipleSelection.length;

          if (length > 0) {
            for (let i = 0; i < length; i++) {
              this.delarr.push(this.multipleSelection[i].dictId);
            }
            const dictIds = this.delarr.join(",");
            deleteitem({ dictIds: dictIds })
              .then(() => {
                this.$notify({
                  title: "成功",
                  message: "删除成功",
                  type: "success",
                  duration: 2000,
                });
                this.getList();
              })
              .catch(() => { });
          } else {
            this.$notify({
              title: "警告提示",
              message: "请选择要删除的信息！",
              type: "warning",
            });
          }
        })
        .catch(() => { });
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
  }
}
</script>
<style>
.ad-avatar-uploader .el-upload {
  border: 1px dashed #d9d9d9;
  border-radius: 6px;
  cursor: pointer;
  position: relative;
  overflow: hidden;
}

.ad-avatar-uploader .el-upload:hover {
  border-color: #409EFF;
}

.ad-avatar-uploader-icon {
  font-size: 28px;
  color: #8c939d;
  width: 178px;
  height: 178px;
  line-height: 178px;
  text-align: center;
}

.ad-avatar {
  display: block;
}
</style>
  